unit nibbtext;

INTERFACE
var
  keinSpielerGewaehltTxt, zuVieleSpielerTxt, hinzufuegenTxt, nichtAendernTxt,
  joystickBenutzenTxt, tastenFestlegenTxt, nameEingebenTxt, nameVorhandenTxt,
  farbeWaehlenTxt, schlangeAendernTxt, hinzugefuegtTxt, joy1joy2Txt,
  joyProblemeTxt, geschw0Txt, holGeschwTxt, relativeSteuerungTxt,
  holSiegPunkteTxt: string[85];

  holBFarbTxt, holWFarbTxt, levelWahlTxt: string[69];

  spielStartenTxt, spielerHinzufuegenTxt, optionenTxt, beendenTxt,
  hauptmenuTxt, joyTxt, geschwindTxt, bodenFarbTxt, wandFarbTxt,
  siegPunkteTxt, mehrAlsTxt: string[24];

  linksTxt, rechtsTxt, hochTxt, runterTxt, zufallTxt, standardTxt, punkteTxt:
    string[10];

  joyZentrierTxt, joyBewegeTxt, joyKnopfTxt: string[40];

  endGrundTxt: array[1..3] of string[64];
  endGameTxt, superTxt, endTitelTxt, knopfDrueckenTxt: string[64];
  ueberlebteTxt, selbstmordTxt, wandTxt, todesursacheTxt, erledigteTxt: string[30];

function texteLesen(var sprache: string): boolean;

IMPLEMENTATION
uses
  dos, nibbserv;

function texteLesen(var sprache: string): boolean;
var
  datei: text;
  erfolgreich: boolean;
  dirInfo: SearchRec;
  i: byte;

  function holZeile: string;
  var
    zeile: string;
  begin
    zeile:= '//error: MissingText';
    while ( (not eof(datei)) and
            ( (zeile = '') or ((zeile[1] = '/') and (zeile[2] = '/')) ) ) do
      readln(datei, zeile);
    holZeile:= zeile;
  end;

  function spracheWaehlen: string;
  type
    daten = ^inhalt;
    inhalt = record
               name: string[8];
               naechster: daten;
             end;
  var
    eingabe: byte;
    anker, lauf, temp: daten;
    nSprache: string[8];
  begin
    anker:= nil;
    lauf:= nil;
    writeln;
    writeln;
    writeln('First use. Chose a language: ');
    i:= 0;
    FindFirst('*.vlf', Archive, DirInfo);
    while DosError = 0 do
    begin
      inc(i);
      delete(dirInfo.name, (length(dirInfo.name) - 3), length(dirInfo.name));
      writeln('  ', i:2, ': ', dirinfo.name);
      new(temp);
      temp^.naechster:= nil;
      temp^.name:= dirInfo.name;
      if anker = nil then anker:= temp
                     else lauf^.naechster:= temp;
      lauf:= temp;
      FindNext(DirInfo);
    end;
    writeln;
    write('Found ', i, ' vNibbles Language Files. Enter number of language or ''0'' to quit: ');
    readln(eingabe);
    if ((eingabe = 0) or (eingabe > i)) then halt
    else
    begin
      i:= 1;
      lauf:= anker;
      while lauf <> nil do
      begin
        if i = eingabe then nSprache:= lauf^.name;
        inc(i);
        temp:= lauf;
        lauf:= lauf^.naechster;
        dispose(temp);
      end;
      spracheWaehlen:= nSprache;
    end;
  end;

begin
  if sprache = '' then sprache:= spracheWaehlen;
  assign(datei, sprache + '.vlf');
  {$i-}
  reset(datei);
  {$i+}
  if ioresult = 0 then
  begin
    {mainMenu}
    spielStartenTxt:= holZeile;
    spielerHinzufuegenTxt:= holZeile;
    optionenTxt:= holZeile;
    beendenTxt:= holZeile;
    keinSpielerGewaehltTxt:= holZeile;
    {addPlayerMenu}
    zuVieleSpielerTxt:= holZeile;
    hinzufuegenTxt:= holZeile;
    nichtAendernTxt:= holZeile;
    nameEingebenTxt:= holZeile;
    nameVorhandenTxt:= holZeile;
    joystickBenutzenTxt:= holZeile;
    relativeSteuerungTxt:= holZeile;
    tastenFestlegenTxt:= holZeile;
    farbeWaehlenTxt:= holZeile;
    schlangeAendernTxt:= holZeile;
    hinzugefuegtTxt:= holZeile;
    {directions}
    linksTxt:= holZeile;
    rechtsTxt:= holZeile;
    hochTxt:= holZeile;
    runterTxt:= holZeile;
    {optionsMenu}
    hauptmenuTxt:= holZeile;
    joyTxt:= holZeile;
    geschwindTxt:= holZeile;
    bodenFarbTxt:= holZeile;
    wandFarbTxt:= holZeile;
    siegPunkteTxt := holZeile;
    joy1joy2Txt:= holZeile;
    joyProblemeTxt:= holZeile;
    joyZentrierTxt:= holZeile;
    joyBewegeTxt:= holZeile;
    joyKnopfTxt:= holZeile;
    holGeschwTxt:= holZeile;
    geschw0Txt:= holZeile;
    holBFarbTxt:= holZeile;
    holWFarbTxt:= holZeile;
    standardTxt:= holZeile;
    zufallTxt:= holZeile;
    holSiegPunkteTxt := holZeile;
    {andere}
    levelWahlTxt:= holZeile;
    {bilanz}
    endTitelTxt := holZeile;
    endGrundTxt[1] := holZeile;
    endGrundTxt[2] := holZeile;
    endGrundTxt[3] := holZeile;
    ueberlebteTxt := holZeile;
    selbstmordTxt := holZeile;
    wandTxt := holZeile;
    todesursacheTxt := holZeile;
    erledigteTxt := holZeile;
    knopfDrueckenTxt := holZeile;
    {victory}
    superTxt := holZeile;
    mehrAlsTxt := holZeile;
    punkteTxt := holZeile;
    endGameTxt := holZeile;
    close(datei);
    texteLesen:= true;
  end
  else texteLesen:= false;
end;

end.